//
// Created by ascadian on 7/25/17.
//

#ifndef DYNCAM_BASECAM_H
#define DYNCAM_BASECAM_H

#include <set>
#include <opencv2/opencv.hpp>

#include "src/ReactDomain.h"
#include "src/Core/StreamCollection.h"
#include "src/Core/Intrinsics.h"

// TODO: we shoudl move the cam into this namespace
using namespace dyncam;

class BaseCam{
public:
    BaseCam() {}
    /// represents the current state of the camera driver
    enum class State {
        DEVICE_UNINITIALIZED, ///< No connection or data streams have been set up
        DEVICE_FAILED, ///< Opening device failed
        DEVICE_OPEN, ///< Connection established with Kinectv2 sensor
        DEVICE_CLOSED ///< Freenect2Cam is closed. To restart, use Freenect2Cam::Connect()
    };

    // current State of the camera
    State state = State::DEVICE_UNINITIALIZED;

    virtual bool Open() {return false;};
    virtual void Close() {};

    virtual std::set<StreamTypes> getStreamCapabilities() = 0;

    D::VarSignalT <State> m_state = MakeVar<D>(State::DEVICE_UNINITIALIZED);

    StreamCollection Streams;
};


#endif //DYNCAM_BASECAM_H
