
#include "Freenect2CamManager.h"

namespace dyncam {

std::vector<std::unique_ptr<Freenect2Cam>>& Freenect2CamManager::FindDevices() {
    libfreenect2::setGlobalLogger(libfreenect2::createConsoleLogger(libfreenect2::Logger::Debug));

    numDevices = freenect2.enumerateDevices();
    //connectedDevices = vector<Freenect2Cam *>();
    for (int i = 0; i < numDevices; i++) {
        std::string serial = freenect2.getDeviceSerialNumber(i);
        connectedDevices.push_back(std::make_unique<Freenect2Cam>(serial));
    }
    return connectedDevices;
}


} // namespace dyncam