//
// Created by ascadian on 4/4/19.
//

#include <src/Core/ImageStream.h>
#include "CompressedStream.h"
#include "src/Core/ImageStream.h"


namespace dyncam {

CompressedStream::CompressedStream() : Stream() {

}

CompressedStream::CompressedStream(std::shared_ptr<ImageStream> stream,
                                   std::shared_ptr<BaseCompression> compression)
                                   : Stream(StreamTypes::COMPRESSED),
                                   m_innerStream(std::move(stream)),
                                   m_compression(move(compression)) {

}

std::string CompressedStream::ToString() {
    return "Compressed stream of " + m_innerStream->ToString() + " with " + m_compression->ToString();
}

} // namespace dyncam