#include <utility>

//
// Created by ascadian on 9/21/18.
//

#include "RequestStreams.h"

namespace dyncam {

RequestStreams::RequestStreams(const int streamID, const StreamTypes streamType) :
    m_requestCollection(false), m_streamID(streamID), m_streamType(streamType) {

}

bool RequestStreams::isCollectionRequest() {
    return m_requestCollection;
}

int RequestStreams::getStreamID() {
    return m_streamID;
}

RequestStreams::RequestStreams(int streamID, const StreamTypes streamType, std::shared_ptr<BaseCompression> compression)
    : RequestStreams(streamID, streamType) {
    m_compression = std::move(compression);
}

StreamTypes RequestStreams::getType() {
    return m_streamType;
}

std::shared_ptr<BaseCompression> RequestStreams::GetCompression() {
    return m_compression;
}

} // namespace dyncam {