//
// Created by ascadian on 9/24/18.
//

#pragma once

#include "ClientBase.h"

namespace dyncam {

class IntrinsicsStream;
class ImageStream;
class CompressedStream;

class StreamClient : public ClientBase {
public:
    StreamClient();


    void requestStream(std::shared_ptr<ImageStream> stream);
    void requestStream(std::shared_ptr<dyncam::IntrinsicsStream> stream);
    void requestStream(std::shared_ptr<dyncam::CompressedStream> stream);
    std::unique_ptr<StreamCollection> m_streams;

protected:
    void on_connected() override;

    void sendListRequest();
    void readStreamColl();

    // use a list as vector needs the elements to be copyable
    std::list<std::unique_ptr<ClientBase>> m_streamSessions;
};

} // namespace dyncam {


