//
// Created by ascadian on 11/30/17.
//

#pragma once
#include "../ReactDomain.h"
#include "BaseCompression.h"
#include <opencv2/opencv.hpp>

namespace dyncam {

class QuantizedCompression : public BaseCompression {
protected:
    // FIXME: check for this in the input and set this to max of CV_16U_C1
    int m_maxDist = 8 * 1000; // 8m in mm


public:
    QuantizedCompression();


    template<class Archive>
    void serialize(Archive & ar)
    {
        ar (m_maxDist);
    }

    EventsT<cv::Mat> compress(const EventsT<cv::Mat> &inStream) override;
    EventsT<cv::Mat> deCompress(const EventsT<cv::Mat> &inStream) override;

    std::string ToString() override;
};

} // namespace dyncam

CEREAL_REGISTER_TYPE(dyncam::QuantizedCompression)
CEREAL_REGISTER_POLYMORPHIC_RELATION(dyncam::BaseCompression, dyncam::QuantizedCompression)

