//
// Created by ascadian on 6/21/18.
//

#include "ImageStream.h"

namespace dyncam {

ImageStream::ImageStream() : Stream()
    , events(MakeEventSource<D, cv::Mat>())
    , m_resolution(MakeVar<D>(cv::Size()))
    , m_cvPixelType(MakeVar<D>(-1))  {
}

ImageStream::ImageStream(StreamTypes type, int parent_id, cv::Size resolution, int cvPixelType)
    : ImageStream()
{
    stream_type_ = type;
    parent_id_ = parent_id;
    m_resolution.Set(resolution);
    m_cvPixelType.Set(cvPixelType);
    D::SetNodeName(*events.ptr_, ToString());
}


std::string ImageStream::ToString() {
    std::stringstream description;
    description << "ImageStream{ id=" << id_;
    description << ", parent_id=" << parent_id_;
    description << ", resolution=" << m_resolution();
    description << ", cvPixelType=" << m_cvPixelType();

    return description.str();
}

} // namespace dyncam