//
// Created by ascadian on 2/21/18.
//

#pragma once

#include <QDockWidget>
#include <opencv2/opencv.hpp>

#include "src/ReactDomain.h"
#include <src/Reconstruction/CloudFromDepth.h>
#include "src/Cams/BaseCam.h"

namespace Ui {
    class CameraWidget;
}

class CameraWidget : public QDockWidget
{
Q_OBJECT

public:
    explicit CameraWidget(QWidget *parent = nullptr);
    ~CameraWidget() override;

    void setCam(StreamCollection streams);

protected:

    StreamCollection mCam;
    Ui::CameraWidget *ui;

    std::shared_ptr<CloudFromDepth> m_pointsMapper;

    void on_source_selected(int index);

};


