//
// Created by ascadian on 12/5/17.
//

#pragma once

#include <QDockWidget>
#include <opencv2/opencv.hpp>
#include "src/ReactDomain.h"
#include "FrameTime.h"
#include "src/Cams/BaseCam.h"

namespace Ui {
    class StreamWidget;
}

class StreamWidget : public QDockWidget
{
Q_OBJECT

public:

    explicit StreamWidget(QWidget *parent = nullptr);
    ~StreamWidget() override;

    void setEvent(EventsT<cv::Mat> &event, StreamTypes type);

    void setEventCloud(EventsT<cv::Mat> &pos,
                       EventsT<cv::Mat> &color);
    void setEventCloud(EventsT<cv::Mat> &pos);
protected:
    void updateStats();

    void detachObservers();

    Ui::StreamWidget *ui;
    ObserverT m_observer;
    ObserverT m_observer2; // we need two for colored clouds

    QWidget* visWidget = new QWidget();

    FrameTime m_frameTimer;

};


